#pragma once

#include <iostream>
#include "vq.h"
class ProgressCallback;

class SSTD_API LVQ : public VQ{

	ProgressCallback * p_cb;

	bool isInWindow( const DistanceInfo & m1, const DistanceInfo & m2 , double windowsize);	
	void lvq2_correct( Codeword * sameClass, Codeword * diffClass, const Codeword & word, double alpha );
	
	void train_lvq1( const Codeword & word, double alpha );
	void train_lvq2( const Codeword & word, double alpha, double window );
	void train_lvq2_1( const Codeword & word, double alpha, double window );
	void train_lvq3( const Codeword & word, double alpha, double window, double epsilon );

public:
	LVQ(ProgressCallback * p_cb = nullptr) : p_cb(p_cb) {}
	LVQ(const Codebook & rhs, ProgressCallback * p_cb = nullptr) : VQ(rhs), p_cb(p_cb) {}
	LVQ(Codebook && rhs, ProgressCallback * p_cb = nullptr) : VQ(std::forward<Codebook&&>(rhs)), p_cb(p_cb) {}
	
	LVQ & operator=(const Codebook & rhs) {
		VQ::operator=(rhs);
		return *this;
	}
	
	LVQ & operator=(Codebook && rhs)  {
		VQ::operator=(std::forward<Codebook&&>(rhs));
		return *this;
	}
	
	void train_vq( const Codebook & cb_in, unsigned int iterations, double window = 0.3, double alpha = 0.01, double epsilon = 0.2 );

	static VQ create( const Codebook & trainingData, unsigned int som_rows = 3, unsigned int som_cols = 3, ProgressCallback * p_cb = nullptr );

};












