#pragma once
#include "exportrules.h"

#include <cmath>
#include <string>


class SSTD_API Benchmark {
	unsigned int * freq;
	const unsigned int scale_step;
	const unsigned int scale_min;
	const unsigned int scale_max;
	const unsigned int size;

	unsigned int min, max;
	unsigned long long total_obs;
	unsigned long long total;
	double sq_diff;

	std::string printGraph(unsigned int val);
	void addObservation(unsigned int val);

public:
	Benchmark( unsigned int scale_step,	unsigned int scale_min,	unsigned int scale_max);
	~Benchmark() ;
	void printObservations();

	template <class T> void analyse( T * data, unsigned int size );
};

	template <class T>
	void Benchmark::analyse( T * data, unsigned int size ) {
		for ( unsigned int i = 0; i < size; i++) {
			addObservation(data[i]);
		}

		long mean = total/total_obs;

		// Calculate variance:
		for ( unsigned int i = 0; i < size; i++) {
			unsigned long long diff = abs(static_cast<long >(data[i])-mean);
			sq_diff += diff*diff;
		}
	}



