#pragma once
#include "codebook.h"

class SSTD_API VQ : public Codebook{
public:
	struct DistanceInfo {
		Codeword 		 *cword;
		Vector::ElemType distance;
	};

public:
	VQ() = default;
	VQ(const Codebook & rhs) : Codebook(rhs) {}
	VQ(Codebook && rhs) : Codebook(std::forward<Codebook&&>(rhs)) {}
	
	VQ & operator=(const Codebook & rhs) {
		Codebook::operator=(rhs);
		return *this;
	}
	
	VQ & operator=(Codebook && rhs)  {
		Codebook::operator=(std::forward<Codebook&&>(rhs));
		return *this;
	}
	
	std::pair<DistanceInfo, DistanceInfo> getClosest2Codewords(const Vector & vec);
	DistanceInfo getClosestCodeword(const Vector  & vec);
	
	unsigned int encode( const Vector  & vec ) const {
		return const_cast<VQ*>(this)->getClosestCodeword(vec).cword->label();
	}

	const std::string & str_encode( const Vector & vec) const {
		return getLabelString(encode(vec));
	}
};
