#include "comp_fmt.h"
#include <fstream>
#include <stdexcept>

using namespace std;

std::vector<unsigned int> load_comp( const std::string & fn ) {
	ifstream fin(fn);
	
	if (!fin) {
	   throw runtime_error("Could not open file: " + fn);
	}
	
	std::vector<unsigned int> ret;
	unsigned int temp;
	while (fin >> temp) {
		ret.push_back(temp);
	}
	
	return ret;
	
}
void save_comp( const std::string & fn, const std::vector<unsigned int> & comp ) {
	ofstream fout(fn);
	
	if (!fout) {
	   throw runtime_error("Could not open file: " + fn);
	}
	
	for (auto elem : comp ) {
		fout << elem << ' ';
	}
}
