#include "progress_callback.h"

#include <iostream>
#include <iomanip>
#include <ctime>

using namespace std;

const int BAR_WIDTH = 50;

void ProgressCallback::updateProgress(double percentage,  const char * label) {
    if ( percentage < 100.0 &&  tick == time(0)) {
        return;
    }
    else {     
		cout << '\r' << label;
		int i = 0;
	
		int progress = static_cast<int>(percentage * BAR_WIDTH/100.0);

		while ( i < progress ) {
			cout << '#';
			i++;
		}
		while (i < BAR_WIDTH) {
			cout << '-';
			i++;
		}
	
		int prec = 1;
		cout << fixed << setprecision(prec) << setw(7) << percentage << '%' << flush;
	
		if (percentage == 100.0) {
			cout << endl;
		}
		
		tick = time(0);
	}
}
