
#include "raw2diff.h"
#include <limits>


SSTD_API void raw2diff(diff_t * diff_data, const raw_t * absData, const int N, const unsigned int CACHE_SETS ) {
	static const raw_t DIFF_MAX = (1<<(8*DIFF_T_SIZE))-1;
	for ( int i = 0; i < N*CACHE_SETS; i++) {
		if (absData[i] > DIFF_MAX)
			diff_data[i] = static_cast<diff_t>(DIFF_MAX);
		else
			diff_data[i] = static_cast<diff_t>(absData[i]);
	}
}

