#include "vq.h"
#include <utility>

using namespace std;

std::pair<VQ::DistanceInfo, VQ::DistanceInfo> VQ::getClosest2Codewords(const Vector & vec){
	unsigned int di;
	DistanceInfo closest = 	{ &((*this)[0]), d_2(vec, (*this)[0]) };
	DistanceInfo runnerup = { &((*this)[1]), d_2(vec, (*this)[1]) };
			
	if ((runnerup.distance) < closest.distance) {
		swap(runnerup, closest);
	}

	for ( int i = 2; i < size(); i++) {
		di = d_2(vec, (*this)[i]);

		if (di < closest.distance) {
			runnerup = closest;
			closest.cword = &((*this)[i]);
			closest.distance = di;
		}					
		else if (di < runnerup.distance) {
			runnerup.cword = &((*this)[i]);
			runnerup.distance = di;
		}
	}

	return make_pair(closest, runnerup);
}
	
VQ::DistanceInfo VQ::getClosestCodeword(const Vector & vec) {
	unsigned int di;
	DistanceInfo candidate = { &((*this)[0]), d_2(vec, (*this)[0]) };
	
	for ( int i = 1; i < size(); i++) {
		di = d_2(vec, (*this)[i]);

		if (di < candidate.distance) {
			candidate.cword = &((*this)[i]);
			candidate.distance = di;
			
		}			
	}
	return candidate;
}
