#include "simple_rsa.h"
#include "options.h"
#include <stdio.h>
#include <time.h>
#include <openssl/rand.h>



int main(int argc, char ** argv) {

	
	time_t t = time(0);
	RAND_seed(&t, sizeof(time_t));

	RSA* rsa = process_args(argc, argv);
	
	const char * pubk = BN_bn2hex(rsa->e);
	const char * privk = BN_bn2hex(rsa->d);
	const char * mod = BN_bn2hex(rsa->n);

	printf("Public key:\n  %s\n", pubk );	
	printf("Private key:\n  %s\n", privk );
	printf("Modulus:\n  %s\n", mod );

	BIGNUM *base;
	base = BN_new();
	BN_init(base);
	BN_rand(base, 1024, 1, 0);

	FILE* filp = fopen("keys", "wt");
	if (!filp) { printf("[Error] Could not open key-file for writing.\n"); return -1; }
	fprintf(filp, "%s\n%s\n%s\n", pubk, mod, privk);
	fclose(filp);

	while ( 1 ) {	
		rsa_decrypt(base, base, rsa->n, rsa->d);
	}

	BN_free(base);
	OPENSSL_free( (void*)pubk );	
	OPENSSL_free( (void*)privk );
	OPENSSL_free( (void*)mod );
	
}


