#!/bin/bash
function run_case () { # Args: tag_name, spy_rounds
	echo $1 $2 $3
	
	rm -f begin_loop;

	echo "Starting Training Process";

	taskset -c 3 ./ex2-training $1 & 
	TRAINING_PID=$!
	
	while [ ! -e begin_loop ]; do
		sleep 1;
	done

	sleep 1

	echo "Starting spy";

	taskset -c 3 spy $1 $2

	kill -15 $TRAINING_PID
}

make clean;
make all;
if [ $? -ne 0 ]; then
	exit $? ;
fi

make -Cscaling all;
if [ $? -ne 0 ]; then
	exit $? ;
fi

run_case "init" 10000
run_case "mod_mul" 10000
run_case "mod_sqr" 10000

echo "Measuring timing of individual operations"
./scaling/timing
cat parameters
	
#raw2pgm init.raw -oinit.pgm
#raw2pgm mod_mul.raw -omod_mul.pgm
#raw2pgm mod_sqr.raw -omod_sqr.pgm

rm -f begin_loop
echo Done!
