S0 = imread('zeros_0.pgm');

S1 = imread('ones_0.pgm');
for i = 1:9
	S0 = [S0; imread(['zeros_' num2str(i) '.pgm'])];
	S1 = [S1; imread(['ones_' num2str(i) '.pgm'])];
end

disp('Loaded input')
var0 = var(S0);
var1 = var(S1);
avgvar0 = mean(var0') 
avgvar1 = mean(var1')


mu0  = mean(S0);
mu1  = mean(S1);


figure(1);
hold on;
plot(var0, 'bx')
plot(avgvar0*ones(size(var0)), 'b-')
plot(var1, 'r+')
plot(avgvar1*ones(size(var1)), 'r-')
title('Variance by cache set')
axis([0 256 40 220])
legend('s = 0', 's = 0 Avg', 's = 1', 's = 1 Avg')
hold off;
print 'variance-access.png';

figure(2);
plot(mu0, 'bx') 
hold on;
plot(mu1, 'r+')
title('Mean access time by cache set')
legend('s = 0', 's = 1')
axis([0 256 40 60])
hold off;
print 'mean-access.png';

% Estimate P( l | s)

function x = h(correct, guess, L, Pls, Psl)
		x = 0;
		for l = L
			if (Psl(l+1, guess+1) != 0)
				x = x - Pls(correct+1, l+1)*log2(Psl(l+1, guess+1));
			end
		end
	end

function H = entropy_matrix(set, S0, S1)

	S = [0 1];
	L = [0:1:255];

	l0 = histc(S0(:, set), L);
	l1 = histc(S1(:, set), L);

	l0 = l0./sum(l0);
	l1 = l1./sum(l1);

	Pls = [l0'; l1'];
	Psl = sum(Pls);
	Psl = Pls ./ [Psl; Psl];
	Psl = Psl';

	Psl(isnan(Psl)) = 0;
	
	H = [h(0,0, L, Pls, Psl) h(0,1, L, Pls, Psl);
		 h(1,0, L, Pls, Psl) h(1,1, L, Pls, Psl) ];
end

set = 149;
h = figure(3);
xvals = [1:5:256];
hist([S0(:,set), S1(:,set)], xvals)
legend('s = 0', 's = 1');
xlim([0, 120]);
xlabel('Access time');
title(['Cache set: ' num2str(set-1)])
print 'access-histogram.png';


S = [0 1];
L = [0:1:255];

l0 = histc(S0(:, set), L);
l1 = histc(S1(:, set), L);

l0 = l0./sum(l0);
l1 = l1./sum(l1);

Pls = [l0'; l1'];
Psl = sum(Pls);
Psl = Pls ./ [Psl; Psl];
Psl = Psl';

Psl(isnan(Psl)) = 0;
 
fig = figure (4);
plot(Pls(1,:), 'b-', Pls(2,:), 'r-');
legend('s = 0', 's = 1');
xlim([0 120])
xlabel('Access Time')
ylabel('Probability')
title(['Cache set: ' num2str(set-1)])
print 'P-l-given-s.png';


fig = figure (5);
plot(Psl'(1,:),'b-', Psl'(2,:),'r-');
legend('s = 0', 's = 1');
xlabel('Access Time')
ylabel('Probability')
title(['Cache set: ' num2str(set-1)])
print 'P-s-given-l.png';

H = entropy_matrix(set, S0, S1)

%Calculate all Entropies.

threshold = 0.01
counter = 0
printf( "\\begin{tabular}{rr} \n Cache set & $I(S,\\tilde{\\vec L}_q)$ \\\\ \\hline \n")
for i = 1:256
	H = entropy_matrix(i, S0, S1);
	sound = H(1,1) < H(1,2) && H(2,1) > H(2,2);		
	if (sound )
		MI = 1 - 0.5*(H(1,1) + H(2,2));
		if (MI > threshold)
			printf( "%3d &  %.4f \\\\\n", i-1, MI);
			counter = counter +1;
		end
	else
		printf( "%3d &  Not Sound\\\\\n", i-1);
		counter = counter +1;
	end
	if (counter > 34)
		printf( "\\hline \\end{tabular} \n \\begin{tabular}{rr} \n Cache set & $I(S,\\tilde{\\vec L}_q)$ \\\\ \\hline \n")
		counter = 0;
	end
end
printf( "\\hline \\end{tabular}\n");

