#pragma once

#include "vector.h" 

struct pkey_elem {
	unsigned int max_elem;
	uiVec          labels;
};



using partial_key = Vector_t<pkey_elem>;

double score_single( const typename partial_key::ElemType & vec) {
     // vec[0] always hold maximum.
	 double sum = vec[0]*vec[0];
	 typename ivec::ElemType l2;
	 vec.norm2(&l2);
	 return sum / l2;
}

double score(const partial_key &key) {
	double sum = 0;
    for (auto & elem : key) {
        sum += score_single(elem);
	}
	return sum;
}

