#include "split.h"

std::vector<std::string> splitStrings(const std::string & inStr, char delim, size_t delim_count ) {
	size_t start = 0;
	std::vector<std::string> ret;

	while (start < inStr.size()) {
		size_t first_delim = inStr.find(delim, start),
			   next_non_delim  = inStr.find_first_not_of(delim, first_delim);

		while (first_delim != std::string::npos && next_non_delim-first_delim < delim_count) {
           first_delim = inStr.find(delim, next_non_delim);
		   next_non_delim  = inStr.find_first_not_of(delim, first_delim);
		}

		if (first_delim - start > 1) { // strings of only one character are purged.
			size_t length = first_delim == std::string::npos ? std::string::npos : first_delim-start;
            ret.emplace_back(inStr.substr(start, length));
		}

		start = next_non_delim;
	}

	return ret;
}
