#pragma once

#include "codebook.h"

#include <string>
#include <unordered_map>
#include <vector>


class Loader {
	std::unordered_map<std::string, Codebook*> codebooks;
	std::vector<unsigned int> reduced_components;	
	Codebook & getCodebook(const std::string & tag);

public:
	int loadRaw( const std::string & fn, const std::string & tag);
    int loadPgm( const std::string & fn, const std::string & tag);	
	int loadCodebook(const std::string & fn );
	
	void setReducedComponents(const std::vector<unsigned int> & comps) {
		reduced_components = comps;
	}
	
	std::vector<unsigned int> getReducedComponents() const {
		return reduced_components;
	}
	
	/** Reduce all codewords */
	void reduce();
	Codebook combineAll();
};	
	

