#pragma once

#include <cstdio>

enum LOGLEVEL {
	ERROR = 0,
	WARNING,
	INFO, //default
	VERBOSE,
	VERY_VERBOSE,
	DEBUG,
};

void incLogLevel();
void setLogLevel(LOGLEVEL loglevel);
LOGLEVEL getLogLevel();

template<typename... argT>
inline void log(LOGLEVEL llvl, argT... args) {
	if (llvl <= getLogLevel()) {
		printf(args...);
	}
}

inline void log(LOGLEVEL llvl, const char *str) {
	if (llvl <= getLogLevel()) {
		printf("%s", str);
	}
}

#include <string>
inline void log(LOGLEVEL llvl, const std::string &str) {
	if (llvl <= getLogLevel()) {
		printf("%s", str.c_str());
	}
}
