#pragma once

#include <set>
#include <string>
#include <map>
#include <utility>


struct Options {
	std::string	  	out = "default.cb";
	std::string	  	vq_out = "default-vq.cb";
	std::string     reduce_in = "";
	
	bool quiet  = false;
	bool append = false;
	bool reduce = false;
	bool info   = false;
	bool batch  = false;
	bool create_vq = false;
	
	std::map<std::string,std::string> 	infiles;
	std::set<std::string> 		  	    codebooks;

	// SOM/VQ options
	unsigned int node_hint = 25;
	unsigned int iteration_hint = 1;

};

extern Options options;
