#include <cstring>
#include <fstream>
#include <iostream>
#include <cstdio>
#include <ctime>
#include <openssl/rand.h>
#include <openssl/rsa.h>
#include <openssl/bn.h>

using namespace std;

#define SIZE 1024

#define WRITE(bignum) { char *hex = BN_bn2hex(bignum); fout << hex << endl; OPENSSL_free(hex);}

int main(int argc, char **argv) {
	
	if (argc != 2) {
		cout << "must supply filename" << endl;
		return 1;
	}

	ofstream fout(argv[1]);
	if (!fout) {
		cout << "Could not open file " << argv[1] << endl;
		return 1;
	}

	time_t t = time(0);
	RAND_seed(&t, sizeof(time_t));

	RSA *rsa = RSA_new();

	BIGNUM e;
	BN_init(&e);
	BN_set_word(&e, 65537);
	RSA_generate_key_ex(rsa, 1024, &e, NULL);

	 
	WRITE(rsa->p);
	WRITE(rsa->q);
	WRITE(rsa->n);
	WRITE(rsa->e);
	WRITE(rsa->d);

	fout.close();
	RSA_free(rsa);	

	return 0;
}
